let center = SMap.Coords.fromWGS84(14.1, 50.1);
let m = new SMap(JAK.gel("m"), center);
m.addDefaultLayer(SMap.DEF_BASE).enable();
var mouse = new SMap.Control.Mouse(SMap.MOUSE_PAN | SMap.MOUSE_WHEEL | SMap.MOUSE_ZOOM);
m.addControl(mouse);

let vrstva = new SMap.Layer.Marker();
m.addLayer(vrstva);
vrstva.enable();

var vrstvaGeo = new SMap.Layer.Geometry();
m.addLayer(vrstvaGeo).enable();

const timer = ms => new Promise(res => setTimeout(res, ms));

let kliknuto = function (signal) {
    let event = signal.data.event;
    let coords = SMap.Coords.fromEvent(event, m);
    new SMap.Geocoder.Reverse(coords, geocoding);
}

let geocoding = function (geocoder) {
    let results = geocoder.getResults();
    let node = new Node(results.coords, results.label, 1);
    nodes.push(node);
    changed=true;
}

let signals = m.getSignals();
signals.addListener(window, "map-click", kliknuto);
signals.addListener(window, "marker-drag-stop", stop);
signals.addListener(window, "marker-drag-start", start);

function deleteMarker(element) {
    let tableRow = element.parentNode.parentNode;
    let index = Number(element.parentNode.parentNode.id);
    let theMarker = nodes[index - 1].marker;
    vrstva.removeMarker(theMarker);
    nodes.splice(index - 1, 1);
    tableRow.remove();
    recount(index - 1);
    changed = true;
}

function recount(index) {
    let table = document.querySelector("#markers");
    for (let j = index; j < nodes.length; j++) {
        nodes[j].marker._options.url.childNodes[1].innerHTML = j + 1;
        table.childNodes[j + 2].childNodes[0].innerHTML = j + 1;
        table.childNodes[j + 2].setAttribute("id", j + 1);
        nodes[j].indexMap = j + 1;
    }
}

function search(e) {
    JAK.Events.cancelDef(e);
    let query = JAK.gel("query").value;
    new SMap.Geocoder(query, odpoved);
}

function odpoved(geocoder) {
    if (!geocoder.getResults()[0].results.length) {
        alert("Místo neznámé.");
        return;
    }
    let vysledky = geocoder.getResults()[0].results;
    goToLocation(vysledky[0].coords.x, vysledky[0].coords.y);
}

function deleteAll() {
    let table = document.querySelector("#markers");
    for (let i = 0; i < nodes.length; i++) {
        table.childNodes[2].remove();
    }
    nodes = [];
    vrstva.removeAll();
    vrstvaGeo.removeAll();
    changed = true;
}


function goToLocation(long, lati) {
    let coords = SMap.Coords.fromWGS84(long, lati);
    m.setCenterZoom(coords, 13);
}

function start(e) {
    var node = e.target.getContainer();
    node[SMap.LAYER_MARKER].style.cursor = "help";
    changed = true;
}

function stop(e) {
    var node = e.target.getContainer();
    node[SMap.LAYER_MARKER].style.cursor = "";
    new SMap.Geocoder.Reverse(e.target._coords, geocoder => {
        let results = geocoder.getResults();
        let index = Number(e.target._options.url.childNodes[1].outerText);
        document.querySelector("#markers").childNodes[index + 1].childNodes[1].innerHTML = results.label;
        ind = nodes.findIndex((node) => node.indexMap == index);
        nodes[ind].coords = results.coords;
        nodes[ind].label = results.label;
    });
}

let inputEl = document.getElementById("query");
let suggest = new SMap.Suggest(inputEl, {
    provider: new SMap.SuggestProvider({
        updateParams: params => {
            let c = m.getCenter().toWGS84();
            params.lon = c[0].toFixed(5);
            params.lat = c[1].toFixed(5);
            params.zoom = m.getZoom();
            params.lang = "cs,en";
        }
    })
});

suggest.addListener("suggest", suggestData => {
    goToLocation(suggestData.data.longitude, suggestData.data.latitude);
});
