let markersCounter = 0;

let dstMx;
let nodes = [];
let changed = true;

async function createNodes() {
    deleteAll();
    let lines = document.querySelector("#input").value.split("\n");
    if (document.querySelector("#addresses").checked) {
        for (let i = 0; i < lines.length; i++) {
            let splitLine = lines[i].split(";");
            if (splitLine.length == 1) {
                splitLine.push(1);
            }
            await new SMap.Geocoder(splitLine[0], geocoder => {
                if (!geocoder.getResults()[0].results.length) {
                    alert(splitLine[0] + " tohle neznáme.");
                }
                let node = new Node(geocoder.getResults()[0].results[0].coords, splitLine[0], splitLine[1]);
                nodes.push(node)
            });
            await timer(250);
        }
    } else {
        for (let i = 0; i < lines.length; i++) {
            let splitLine = lines[i].split(" ");
            if (splitLine.length == 2) {
                splitLine.push(1);
            }
            let coords = SMap.Coords.fromWGS84(splitLine[1], splitLine[0]);
            await new SMap.Geocoder.Reverse(coords, geocoder => {
                let label = geocoder.getResults().label;
                let node = new Node(coords, label, splitLine[2]);
                nodes.push(node)
            });
            await timer(250);
        }
    }
}


function exportNodes() {
    fillDemands();
    nodes.sort((a, b) => { return a.indexMap - b.indexMap });
    let textArea = document.querySelector("#input");
    textArea.value = "";
    let i;
    for (i = 0; i < nodes.length - 1; i++) {
        textArea.value += (nodes[i].coords.y + " " + nodes[i].coords.x + " " + nodes[i].k + "\n");
    }
    textArea.value += (nodes[i].coords.y + " " + nodes[i].coords.x + " " + nodes[i].k);
}


function getDepo() {
    let indexDepo = -1;
    let table = document.querySelector("#markers");
    for (let i = 0; i < nodes.length; i++) {
        let radioButton = table.childNodes[i + 2].childNodes[2].lastChild;
        if (radioButton.checked) {
            indexDepo = i;
            break;
        }
    }
    return indexDepo;
}

async function calculate() {
    vrstvaGeo.removeAll();
    indexDepo = getDepo();
    if (indexDepo == -1) {
        alert("Prosím, vyberte depo.");
        return false;
    }
    nodes.sort((a, b) => { return a.indexMap - b.indexMap });
    sortCoords(indexDepo);
    console.log("Počítám dstMX");
    if (changed) {
        await getDistanceMx();
    }

    let solution;
    let alg = document.createElement("span");
    if (document.querySelector("#cw").checked) {
        solution = clarkWright();
        alg.innerHTML = "Clarke & Wright";
    } else {
        solution = nearestNeighbour();
        alg.innerHTML = "Nearest Neighbour";
    }
    let par = document.createElement("p");
    par.appendChild(document.createElement("hr"));
    let dltSol = document.createElement("a");
    dltSol.append("Smazat");
    dltSol.setAttribute("onClick", "deletePar(this.parentNode)");
    dltSol.setAttribute("class", "buttondlt");
    par.appendChild(alg);
    par.appendChild(dltSol);
    par.innerHTML += "<br>";
    par.innerHTML += consoleOutSolution(solution)
    document.querySelector("#solutionDiv").appendChild(par);

    console.log("Solution", solution);
    console.log("Distance", dstMx);
    let totalDistance = getTotalLength(solution);
    console.log("Total Distance, ", totalDistance);
    displaySolution(solution);
}

function nearestNeighbour() {
    let remainingNodes = nodes.slice(1);
    let solution = [[nodes[0]]];
    let k = 0;
    while (remainingNodes.length != 0) {
        let min = Number.MAX_SAFE_INTEGER;
        let closestNode;
        for (let i = 0; i < remainingNodes.length; i++) {
            let testingNode = solution[k][solution[k].length - 1];
            if (dstMx[testingNode.index][remainingNodes[i].index].lengthR < min) {
                min = dstMx[testingNode.index][remainingNodes[i].index].lengthR;
                closestNode = remainingNodes[i];
            }
        }
        if (getLoadOneRoute(solution[k]) + closestNode.k > nodes[0].k) {
            solution[k].push(nodes[0]);
            k++;
            solution[k] = [];
            solution[k].push(nodes[0]);
        } else {
            solution[k].push(closestNode);
            remainingNodes.splice(remainingNodes.indexOf(closestNode), 1);
        }
    }
    solution[k].push(nodes[0]);
    return solution;
}

function getLoadOneRoute(arr) {
    let sum = 0;
    for (let i = 1; i < arr.length; i++) {
        sum += arr[i].k;
    }
    return sum;
}

function clarkWright() {
    let svgMx = getSavings(dstMx);

    let savings = [];
    for (let i = 0; i < svgMx.length; i++) {
        for (let j = i; j < svgMx.length; j++) {
            savings.push(svgMx[i][j]);
        }
    }
    savings = savings.sort((a, b) => { return b.amount - a.amount });
    console.log("Savings", savings);
    let solution = initialSolution(dstMx.length);
    for (let k = 0; k < savings.length; k++) {
        let saving = savings[k];
        let i = saving.edge.from;
        let j = saving.edge.to;
        let iIndex = -1;
        let jIndex = -1;
        let indexFirst = -1;
        let indexSecond = -1;
        for (let l = 0; l < solution.length; l++) {
            let helpingI = solution[l].indexOf(i);
            let helpingJ = solution[l].indexOf(j);

            if (helpingI != -1) {
                if (!(helpingI == 1 || helpingI == solution[l].length - 2)) {
                    break;
                } else {
                    indexFirst = l;
                    iIndex = helpingI;
                }
            }
            if (helpingJ != -1) {
                if (!(helpingJ == 1 || helpingJ == solution[l].length - 2)) {
                    break;
                } else {
                    indexSecond = l;
                    jIndex = helpingJ;
                }
            }

        }
        if (((indexSecond != -1) && (indexFirst != -1)) && (indexFirst != indexSecond)) {
            if (getCount(indexFirst, indexSecond, solution) > nodes[0].k) {
                continue;
            }
            solution = mergeRoutes(iIndex, jIndex, indexFirst, indexSecond, solution);
        }
    }
    return solution;
}

function getCount(indexFirst, indexSecond, solution) {
    let sum = 0;
    for (let i = 1; i < solution[indexFirst].length - 1; i++) {
        sum += solution[indexFirst][i].k;
    }
    for (let i = 1; i < solution[indexSecond].length - 1; i++) {
        sum += solution[indexSecond][i].k;
    }
    return sum;
}

function mergeRoutes(iIndex, jIndex, indexFirst, indexSecond, solution) {
    if (iIndex == 1 && jIndex == 1) {
        solution[indexSecond].shift();
        solution[indexSecond].reverse();
        solution[indexFirst].shift();
        solution[indexSecond] = solution[indexSecond].concat(solution[indexFirst]);
        solution.splice(indexFirst, 1);
    } else if (iIndex == 1 && jIndex != 1) {
        solution[indexSecond].pop();
        solution[indexFirst].shift();
        solution[indexSecond] = solution[indexSecond].concat(solution[indexFirst]);
        solution.splice(indexFirst, 1);
    } else if (iIndex != 1 && jIndex == 1) {
        solution[indexFirst].pop();
        solution[indexSecond].shift();
        solution[indexFirst] = solution[indexFirst].concat(solution[indexSecond]);
        solution.splice(indexSecond, 1);
    } else {
        solution[indexFirst].pop();
        solution[indexSecond].pop();
        solution[indexSecond].reverse();
        solution[indexFirst] = solution[indexFirst].concat(solution[indexSecond]);
        solution.splice(indexSecond, 1);
    }
    return solution;
}

function getTotalLength(solution) {
    let sum = 0;
    for (let i = 0; i < solution.length; i++) {
        for (let j = 0; j < solution[i].length - 1; j++) {
            sum += dstMx[solution[i][j].index][solution[i][j + 1].index].lengthR;
        }
    }
    return sum;
}

function lengthOneRoute(route) {
    let length = 0;
    for (let i = 0; i < route.length - 1; i++) {
        length += dstMx[route[i].index][route[i + 1].index].lengthR;
    }
    return length;
}

function consoleOutSolution(solution) {
    let str = "<br>";
    for (let i = 0; i < solution.length; i++) {
        str += (i + 1) + ". trasa: ";
        for (let j = 0; j < solution[i].length; j++) {
            str += solution[i][j].marker._options.url.outerText + " ";
        }
        str += "<br>Délka trasy: " + lengthOneRoute(solution[i]) / 1000 + " km";
        str += "; Náklad: " + getLoadOneRoute(solution[i].slice(0, solution[i].length - 1)) + "<br><br>";
    }
    str += "<br>Celková délka: " + getTotalLength(solution) / 1000 + " km";
    return str;
}

function initialSolution() {
    let solution = []
    let counter = 0;
    for (let i = 1; i < nodes.length; i++) {
        solution[counter] = [];
        solution[counter].push(nodes[0]);
        solution[counter].push(nodes[i]);
        solution[counter].push(nodes[0]);
        counter++;
    }
    return solution;
}

function fillDemands() {
    let capacity = getDemand();
    for (let i = 0; i < nodes.length; i++) {
        nodes[i].k = capacity[i];
    }
}


function sortCoords(indexDepo) {
    let depo = nodes[indexDepo];
    fillDemands();
    nodes.splice(indexDepo, 1);
    nodes.unshift(depo);
    for (let i = 0; i < nodes.length; i++) {
        nodes[i].index = i;
    }
}

function displaySolution(solution) {
    for (let i = 0; i < solution.length; i++) {
        let options = {
            color: randomColor(),
            width: 5,
            outlineWidth: 1
        };
        for (let j = 0; j < solution[i].length - 1; j++) {
            var g = new SMap.Geometry(SMap.GEOMETRY_POLYLINE, null, dstMx[solution[i][j].index][solution[i][j + 1].index].geometry, options);
            vrstvaGeo.addGeometry(g);
        }
    }
}

function randomColor() {
    let letters = '0123456789ABCDEF';
    let color = '#';
    for (let i = 0; i < 6; i++) {
        color += letters[Math.floor(Math.random() * 16)];
    }
    return color;
}

function getDemand() {
    let table = document.querySelector("#markers");
    let demand = [];
    for (let i = 0; i < nodes.length; i++) {
        let x = table.childNodes[i + 2].childNodes[4].childNodes[0].value;
        if (x == "") {
            x = 1;
        }
        demand.push(Number(x));
    }
    return demand;
}

function getCoords(indexDepo) {
    let markers = vrstva.getMarkers();
    let coords = [];
    for (let i = 0; i < markers.length; i++) {
        let coord = SMap.Coords.fromWGS84(markers[i]._coords.x, markers[i]._coords.y);
        if (i == indexDepo) {
            coords.unshift(coord);
        } else {
            coords.push(coord);
        }
    }
    return coords;
}

async function getDistanceMx() {
    dstMx = new Array();
    for (let i = 0; i < nodes.length; i++) {
        dstMx[i] = new Array(nodes.length).fill(0);
    }
    for (let k = 0; k < nodes.length; k++) {
        for (let j = k + 1; j < nodes.length; j++) {

            let coord = [nodes[k].coords, nodes[j].coords];
            await SMap.Route.route(coord, { geometry: true, criterion: "short" }).then(route => {
                let results = route.getResults();
                let edge = new Edge(nodes[k], nodes[j], results.length, results.geometry, results.time);
                let edgeBack = new Edge(nodes[j], nodes[k], results.length, results.geometry, results.time);
                dstMx[k][j] = edge;
                dstMx[j][k] = edgeBack;
            });
        }
    }
    changed = false;
}

function getSavings(distanceMx) {
    let savingsMx = new Array(distanceMx.length - 2);
    for (let i = 0; i < savingsMx.length; i++) {
        savingsMx[i] = new Array(distanceMx.length - 2).fill(0);
    }
    for (let i = 1; i < distanceMx.length; i++) {
        for (let j = i + 1; j < distanceMx.length; j++) {
            let amount = distanceMx[0][i].lengthR + distanceMx[0][j].lengthR - distanceMx[i][j].lengthR;
            savingsMx[i - 1][j - 2] = new Saving(distanceMx[i][j], amount);
        }
    }
    return savingsMx;
}

function deletePar(element) {
    element.remove();
}

function deleteAllSol() {
    solDiv = document.querySelector("#solutionDiv");
    children = solDiv.childNodes;
    let length = children.length;
    if (children.length > 3) {
        for (let i = 3; i < length; i++) {
            deletePar(children[3]);
        }
    }
}

function modifyPlaceholder(element, radio) {
    var data = {
        addresses: 'Pod Vinicemi 931/2, 30100 Plzeň\nMikoláše Alše 253, Kolín, 280 02, Kolín;14',
        coords: '13.355477294914115 49.760350115918946\n13.370187879846892 49.75818505978941 5',
    };
    element.placeholder = data[radio.id];
}